import { Lexer, Token, TokenType } from '../lexer';
import { ErrorMessage } from './error-message';
import { Expression } from './expression';
import { ParseResult } from './parse-result';
export declare abstract class ParserBase {
    private createLexer;
    private createContext;
    private isLexer;
    private isResolutionContext;
    parse(input: Lexer | string): ParseResult;
    protected abstract parseCore(lexer: Lexer, errors: ErrorMessage[]): Expression;
    protected expectAndConsume(lexer: Lexer, errors: ErrorMessage[], expected: TokenType, actual?: Token): Token;
    protected expect(lexer: Lexer, errors: ErrorMessage[], expected: TokenType, actual?: Token): Token;
    protected errorToken(errors: ErrorMessage[], expected: TokenType, actual: Token): void;
    protected errorMessage(errors: ErrorMessage[], message: string, token: Token): void;
}
