import { Lexer } from '../lexer';
import { ErrorMessage } from './error-message';
import { Expression } from './expression';
import { ParserBase } from './parser-base';
import { ResultEvaluator } from './result-evaluator.type';
export declare class Parser extends ParserBase {
    protected parseCore(lexer: Lexer, errors: ErrorMessage[]): Expression;
    parseExpression(lexer: Lexer, errors: ErrorMessage[]): ResultEvaluator;
    parseSimpleExpression(lexer: Lexer, errors: ErrorMessage[]): ResultEvaluator;
    parseTerm(lexer: Lexer, errors: ErrorMessage[]): ResultEvaluator;
    parseFactor(lexer: Lexer, errors: ErrorMessage[]): ResultEvaluator;
    parseFunction(lexer: Lexer, errors: ErrorMessage[], name?: string[]): ResultEvaluator;
    parseNumber(lexer: Lexer, errors: ErrorMessage[]): ResultEvaluator;
    parseVariable(lexer: Lexer, errors: ErrorMessage[], identifier?: string[]): ResultEvaluator;
    parseBracketedExpression(lexer: Lexer, errors: ErrorMessage[]): ResultEvaluator;
    parseDottedIdentifier(lexer: Lexer, errors: ErrorMessage[]): string[];
}
