"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DEFAULT_FUNCTIONS = {
    abs: Math.abs,
    pow: Math.pow,
    floor: Math.floor,
    ceil: Math.ceil,
    exp: Math.exp,
    log: Math.log,
    log10: Math.log10,
    max: Math.max,
    min: Math.min,
    sign: Math.sign,
    sqrt: Math.sqrt
};
var DefaultResolutionContext = /** @class */ (function () {
    function DefaultResolutionContext(environment) {
        this._environment = {};
        this._mergedEnvironment = DEFAULT_FUNCTIONS;
        this.environment = environment;
    }
    Object.defineProperty(DefaultResolutionContext.prototype, "environment", {
        get: function () {
            return this._environment;
        },
        set: function (value) {
            this._environment = value;
            this._mergedEnvironment = Object.assign({}, DEFAULT_FUNCTIONS, this._environment);
        },
        enumerable: true,
        configurable: true
    });
    DefaultResolutionContext.prototype.resolve = function (name) {
        return name.reduce(function (p, c) { return p[c]; }, this._mergedEnvironment);
    };
    return DefaultResolutionContext;
}());
exports.DefaultResolutionContext = DefaultResolutionContext;
//# sourceMappingURL=resolution-context.js.map